#ifndef _AIM_FPGA_AND_POINT_CPLD_H
#define _AIM_FPGA_AND_POINT_CPLD_H



// headers that we depend upon
//
#include "../apptel/aimfpga.h"
#include "../apptel/cpld.h"



#define AIM_AND_CPLD_BASE_ADDR_REG      4



// merged registers
//
// base address register 4 (the 5th one) in PCI
// configuration space points to both the registers
// in the FPGA on the AIM board, and the registers
// in the CPLD on the POINT board, with the AIM first
//
struct AimAndCpld_registers
{
    Aim_registers Aim;
    Cpld_registers Cpld;
};



#endif      // not included yet
