#ifndef _FPGATEST_H
#define _FPGATEST_H



/* header files we depend upon
 */
#include "../apptel/sram.h"             // sram_init()



/* errors
 */
#define ERROR_FPGA_MISSING_ARGS             100
#define ERROR_FPGA_TEST_INIT_0_MISCOMP      101
#define ERROR_FPGA_TEST_WALK_1_MISCOMP      102
#define ERROR_FPGA_TEST_FINAL_0_MISCOMP     103
#define ERROR_FPGA_TEST_INIT_1_MISCOMP      104
#define ERROR_FPGA_TEST_WALK_0_MISCOMP      105
#define ERROR_FPGA_TEST_FINAL_1_MISCOMP     106
#define ERROR_FPGA_TEST_INIT_0_ADDR_XOR     107
#define ERROR_FPGA_TEST_WALK_1_ADDR_XOR     108
#define ERROR_FPGA_TEST_FINAL_0_ADDR_XOR    109
#define ERROR_FPGA_TEST_INIT_1_ADDR_XOR     110
#define ERROR_FPGA_TEST_WALK_0_ADDR_XOR     111
#define ERROR_FPGA_TEST_FINAL_1_ADDR_XOR    112
#define ERROR_FPGA_TEST_BAD_MAX_ADDRESS     113



/* function prototypes
 */
int fpga_test( Fpga_registers *both_fpgas, AimAndCpld_registers *aim_and_cpld );



#endif  /* not included yet */
