.386p
locals


_TEXT   segment dword public use32 'CODE'
_TEXT   ends
_DATA   segment dword public use32 'DATA'
_DATA   ends
_BSS    segment dword public use32 'BSS'
_BSS    ends
DGROUP  group   _BSS,_DATA

_TEXT   segment dword public use32 'CODE'
    assume cs:_TEXT

    public _real_callback_thunk
_real_callback_thunk proc near

if 0
    ; get the return address from the protected mode alias
    ; of the real mode stack, which we got in DS:ESI
    ;
    mov eax, [esi]

    ; change the CS and IP registers in the RealModeRegs
    ; structure we were passed
    ;
    mov es:[edi + 42], ax       ; IP
    shr eax, 16
    mov es:[edi + 44], ax       ; CS

    ; pop the return address off the real mode stack
    ; (assumes we were called far, not via interrupt)
    ;
    add word ptr es:[edi + 46], 4        ; SP

    ; force the real mode ES and EDI registers to be zero
    ; so the packet driver thinks that we don't want the
    ; packet (only meaningful if we are being called by a
    ; packet driver -- take this out!)
    ;
    ; WARNING: anything you do to the high 16 bits of EDI
    ; in the RealModeRegs structure
    ; will stay there when your normal protected mode code
    ; runs again later, so DON'T MESS WITH THEM!
    ;
    mov word ptr es:[edi + 0], 0    ;di
    mov word ptr es:[edi + 34], 0   ;es

    ; joel debug only
    ;
    iret
endif

    ; remember where the protected mode stack is now
    ;
    mov ax, ss
    mov es:[edi - 10], ax
    mov es:[edi - 14], esp

    ; swap to another stack that is in same segment
    ; as data, so C function can assume so
    ;
    mov ax, es
    mov ss, ax
    mov esp, es:[edi - 8]

    ; make room for the Bit48 structure that the
    ; C code will be returning to us
    ;
    add esp, -8
    mov eax, esp

    ; push the parameters that we got in registers
    ; onto the stack so the C code can use them
    ;

    ; push the 48 bit alias to real mode stack pointer
    ; such that offset is at lower address
    ;
    push ds
    push esi

    ; push the 48 bit pointer to real mode register structure
    ; such that offset is at lower address
    ;
    push es
    push edi

    ; tell the C code where to place the structure it will return
    ;
    push eax

    ; now set DS register to be the same as ES register,
    ; again so the C function can assume
    ;
    mov ax, es
    mov ds, ax

    ; call the user's C code
    ;
    call es:[edi - 4]

    ; get the C parameters off the stack, including
    ; the hidden pointer to the returned structure
    ;
    add esp, 20

if 1
    ; point at whatever real mode registers the C code
    ; wanted us to, so they can be reloaded by the DPMI
    ; host before it switches back to real mode
    ;
    pop edi
    pop es
else
    ; ignore the caller's RealModeRegs pointer
    ;
    add esp, 8
endif

    ; now restore the stack to the way it was
    ; so we can return to the DPMI host
    ;
    mov ax, es:[edi - 10]
    mov ss, ax
    mov esp, es:[edi - 14]

    ; return to DPMI host
    ;
    iret

_real_callback_thunk endp

_TEXT ends

end
