/* helper program to create a table to mirror-swap
 * the bits of a byte, for FDDI MAC addresses
 *
 * normally the output of this program gets included
 * in a statically defined Bit8 array
 */



#define CREATE_TABLE    TRUE




#include <stdio.h>
#include "../types/types.h"


void main( void )
{
    Bit8 bit0, bit1, bit2, bit3, bit4, bit5, bit6, bit7;
    Bit8 count = 0;
    Bit8 current, guess;

    for( bit0=0; bit0<2; bit0++ )
        for( bit1=0; bit1<2; bit1++ )
            for( bit2=0; bit2<2; bit2++ )
                for( bit3=0; bit3<2; bit3++ )
                    for( bit4=0; bit4<2; bit4++ )
                    {
                        for( bit5=0; bit5<2; bit5++ )
                            for( bit6=0; bit6<2; bit6++ )
                                for( bit7=0; bit7<2; bit7++ )
                                {
                                    current = (bit7 << 7)
                                            | (bit6 << 6)
                                            | (bit5 << 5)
                                            | (bit4 << 4)
                                            | (bit3 << 3)
                                            | (bit2 << 2)
                                            | (bit1 << 1)
                                            | bit0;
#if CREATE_TABLE
                                    printf( "0x%.2X, ", current );
#else
                                    guess = (Bit8) (256 - (Bit16)count);
                                    printf( "input=0x%.2X,   output=0x%.2X,   guess=0x%.2X\n", count, current, guess );
                                    count++;
#endif
                                }
#if CREATE_TABLE
                        printf( "\n" );
#endif
                    }
}
