CSEG    SEGMENT PARA PUBLIC 'CODE'
        ASSUME  CS:CSEG,DS:NOTHING,ES:NOTHING,SS:NOTHING


;----------------------------------------------------------------------
;  Start of code
;----------------------------------------------------------------------
                ORG     100H                    ;Starting offset for .com
START:

        if 0
                ; read the keyboard controller's current command
                ; byte and save it in BL register
                ;
                mov ah, KBREADCMD
                call writecmd
                call readdata
                mov bl, al

                ; force the PC compatibility mode to be off, so we see
                ; the exact keycodes that the keyboard sent (excluding
                ; ACK/RESEND type traffic
                ;
                mov ah, KBWRITECMD
                call writecmd
                mov ah, bl
                and ah, NOT KBTRANSLATE
                call writedata

                ; read lots of scancodes into memory
                ;
                mov si, offset scanbuf1
                mov cx, offset scanend1
                sub cx, si
                call readmany

                ; restore the old command byte
                ;
                mov ah, KBWRITECMD
                call writecmd
                mov ah, bl
                call writedata
        else
        if 0
                cli

                ; for 100 iterations of all 256 possible scancodes...
                ;
                ; pressing a key on the actual keyboard should
                ; cause a miscompare... but it doesn't!
                ;
                mov cx, 100d
                xor bh, bh
more:
                call stuffone
                call readdata
                cmp al, bh
                jne one_different
                inc bh
                jnz more
all_same:
                loop more
                mov dx, 1234h
                jmp done
one_different:
                mov dx, 4321h
done:
                sti
        else
                ; point at the first scan code
                ;
                mov si, offset test_scanbuf
                mov cx, test_scanlen
                call stuffmany
        endif
        endif

                ; exit program
                ;
                ret

                include kbstuff.asm

; sequence of scancodes to stuff into the keyboard port
;
        KEYCODE_D   equ  20h
    if 0
test_scanbuf    db  KEYCODE_D, KEYCODE_D | 80h
                db  KEYCODE_D, KEYCODE_D | 80h
                db  KEYCODE_D, KEYCODE_D | 80h
                db  KEYCODE_D, KEYCODE_D | 80h
                db  KEYCODE_D, KEYCODE_D | 80h
                db  KEYCODE_D, KEYCODE_D | 80h
                db  KEYCODE_D, KEYCODE_D | 80h
                db  KEYCODE_D, KEYCODE_D | 80h
                db  KEYCODE_D, KEYCODE_D | 80h
    else
test_scanbuf    db  KEYCODE_D
    if 0
                db  KEYCODE_D
                db  KEYCODE_D
                db  KEYCODE_D
                db  KEYCODE_D
                db  KEYCODE_D
                db  KEYCODE_D
                db  KEYCODE_D
                db  KEYCODE_D
    endif
    endif
test_scanlen    equ $ - test_scanbuf

                ; bogus statements so debugger displays this source file OK
                ;
                mov ax, ax

CSEG            ENDS
                PUBLIC  START                   ;so mapsym doesn't bitch
                END     START
